﻿/*
IDverChecker2019.jsx
(c)2016 Shock tm
ドキュメントオープン時に作成アプリのバージョンを判定する。
2016/09/09 CC以降に対応
2019/04/12 CC2019まで対応
2019/09/10 xml間違い
*/
#target "InDesign"
#targetengine "session"
#targetengine "versionCheck"
var xml='<version CCCS="CS4" major="6">CS4</version>\n';
xml+='<version CCCS="CS5" major="7">CS5</version>\n';
xml+='<version CCCS="CS5.5" major="7.5">CS5.5</version>\n';
xml+='<version CCCS="CS6" major="8">CS6</version>\n';
xml+='<version CCCS="CC" major="9">CC</version>\n';
xml+='<version CCCS="CC2014" major="10">CC2014</version>\n';
xml+='<version CCCS="CC2015" major="11">CC2015</version>\n';
xml+='<version CCCS="CC2017" major="12">CC2017</version>\n';
xml+='<version CCCS="CC2018" major="13">CC2018</version>\n';
xml+='<version CCCS="CC2019" major="14">CC2019</version>\n';
(function(){
    app.addEventListener("afterOpen", versionCheck, false);
    function versionCheck(myEvent){
        if(myEvent.target instanceof LayoutWindow){
            var xd=new XML("<xml>"+xml+"</xml>")
            var DocVer=verGet(app.activeDocument.metadataPreferences.creator);
            var AppVer=verGet(app.version);
            if((DocVer.indexOf("CS")==-1)&(DocVer.indexOf("CC")==-1)){
                DocVer=xd.version.(@major==DocVer);
            }else{
                DocVer=xd.version.(@CCCS==DocVer);
            }
            if((AppVer.indexOf("CS")==-1)&(AppVer.indexOf("CC")==-1)){
                AppVer=xd.version.(@major==AppVer);
            }else{
                AppVer=xd.version.(@CCCS==AppVer);
            }
            if(DocVer.indexOf(AppVer)==-1){
                alert(
                "このドキュメントは【InDesign "+AppVer+"】\nで作成されたものではありません！\n"+
                "作成されたバージョンは【InDesign "+DocVer+"】です！",
                "ドキュメント作成バージョンが違うカモ...")
            }
            //$.writeln(AppVer+":"+DocVer)
        }
    }
})();
//バージョンからアプリ名を取得する関数
function verGet(v){
    if(v.indexOf("CS")!=-1){//CSバージョン表記
        v=v.split("CS")[1];
        if(v[1]=="."){
            v="CS"+v[0]+v[1]+v[2];
        }else{
            v="CS"+v[0];
        }
    }else if(v.indexOf("CC")!=-1){//CCバージョン表記
        v=v.split("CC ")[1];
        if(v.indexOf(".")!=-1){//やっぱりメジャーバージョン表記
            v=v.split(".")[0];
        }else{
            v="CC"+v[0]+v[1]+v[2]+v[3];
        }
    }else{//メジャーバージョン表記
        v=v.replace(/Adobe ?InDesign ?/g,"");
        if(v.split(".")[0]+v.split(".")[1]=="75"){
            v="7.5";
        }else{
            v=v.split(".")[0];
        }
    }
    return v;
}

